-- Functions for testing PL/LOLCODE
-- $Id: testFuncs.sql,v 1.4 2008/02/05 12:41:51 eggyknap Exp $
drop function pl_lolcode_call_handler() cascade;
create function pl_lolcode_call_handler() returns language_handler as 'pllolcode' language c;
create language pllolcode handler pl_lolcode_call_handler;
create function lol_main_test(a text) returns boolean as $$
HAI
	VISIBLE NOTICE "This is a test"
	FOUND YR WIN
KTHXBYE
$$
language pllolcode;
select lol_main_test('This is a test input parameter');
create function lol_arith_test(a int, b int) returns boolean as $$
HAI
	VISIBLE NOTICE "1 This is a test"
	VISIBLE INFO "2 This is a test"
	VISIBLE INFO "First argument"
	VISIBLE INFO LOL1
	VISIBLE INFO "Second argument"
	VISIBLE INFO LOL2
	VISIBLE INFO "Their sum"
	VISIBLE INFO SUM OF LOL1 AN LOL2
	VISIBLE INFO "Their difference"
	VISIBLE INFO DIFF OF LOL1 LOL2
	VISIBLE INFO "Their product"
	VISIBLE INFO PRODUKT OF LOL1 LOL2
	VISIBLE INFO "Their quotient"
	VISIBLE INFO QUOSHUNT OF LOL1 AN LOL2
	VISIBLE INFO "Their modulus"
	VISIBLE INFO MOD OF LOL1 LOL2
	VISIBLE INFO "Their maximum"
	VISIBLE INFO BIGGR OF LOL1 AN LOL2
	VISIBLE INFO "Their minimum"
	VISIBLE INFO SMALLR OF LOL1 LOL2
	FOUND YR WIN
KTHXBYE
$$ language pllolcode;
select lol_arith_test(5, 2);
create function lol_bool_test(a bool, b bool) returns boolean as $$
HAI
	VISIBLE NOTICE "FIRST ARGUMENT"
	VISIBLE NOTICE LOL1
	VISIBLE NOTICE "SECOND ARGUMENT"
	VISIBLE NOTICE LOL2
	VISIBLE NOTICE " NOT 1 "
	VISIBLE NOTICE NOT LOL1
	VISIBLE NOTICE " 1 AND 2 "
	VISIBLE NOTICE BOTH OF LOL1 AN LOL2
	VISIBLE NOTICE " 1 OR 2 "
	VISIBLE NOTICE EITHER OF LOL1 AN LOL2
	VISIBLE NOTICE " NOT 1 OR 2 "
	VISIBLE NOTICE NOT EITHER OF LOL1 LOL2
	VISIBLE NOTICE " ANY OF 1 2 WIN FAIL MKAY "
	VISIBLE NOTICE ANY OF LOL1 LOL2 WIN FAIL MKAY
	VISIBLE NOTICE " ALL OF 1 AN 2 AN WIN AN FAIL MKAY "
	VISIBLE NOTICE ALL OF LOL1 AN LOL2 AN WIN AN FAIL MKAY
	VISIBLE NOTICE " ARE LOL1 AND LOL2 THE SAME? "
	VISIBLE NOTICE BOTH SAEM LOL1 AN LOL2
	VISIBLE NOTICE " ARE LOL1 AND LOL2 DIFFERENT? "
	VISIBLE NOTICE DIFFRINT LOL1 LOL2
	VISIBLE NOTICE " RETURNING 1 XOR 2 "
	FOUND YR WON OF LOL1 LOL2
KTHXBYE
$$ language pllolcode;
create function lol_misc_bool(a bool) returns boolean as $$
HAI
	VISIBLE " ALL OF WIN WIN WIN "
	VISIBLE ALL OF WIN WIN WIN MKAY
	VISIBLE " ALL OF WIN WIN FAIL "
	VISIBLE ALL OF WIN WIN FAIL MKAY
	VISIBLE " ANY OF FAIL FAIL FAIL MKAY"
	VISIBLE ANY OF FAIL FAIL FAIL MKAY
	VISIBLE " ANY OF WIN FAIL FAIL MKAY"
	VISIBLE ANY OF WIN FAIL FAIL MKAY
	VISIBLE " WON OF FAIL WIN, WIN WIN, FAIL FAIL "
	VISIBLE WON OF FAIL WIN
	VISIBLE WON OF WIN WIN
	VISIBLE WON OF FAIL FAIL
KTHXBYE
$$ language pllolcode;
select lol_bool_test(true, true);
select lol_bool_test(true, false);
select lol_bool_test(false, true);
select lol_bool_test(false, false);
select lol_misc_bool(true);
create function lol_type_args_test(a integer, b numeric, c text) returns VOID as $$
HAI
	GIMMEH YR VARZ
KTHXBYE
$$ language pllolcode;
select lol_type_args_test(1, 1.2, 'test');
